unit Unit6;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Series, TeeTools, TeeGDIPlus, ExtCtrls, TeeProcs, TeEngine, Chart,
  TeeEdit, StdCtrls,TeeFunci,StatChar, OHLChart, CandleCh;

type
  TForm6 = class(TForm)
    Chart1: TChart;
    ChartEditor1: TChartEditor;
    Panel1: TPanel;
    Button1: TButton;
    edtSeries: TEdit;
    ListBox1: TListBox;
    Button2: TButton;
    edtMacd: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure Chart1DblClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
     tmpLineSeries:TLineSeries;
     tmpAxis      : TChartAxis;
     tmpMyCandle  : TCandleSeries;
     stockHastic  : TStochasticFunction;
     ChartTool1   : TAnnotationTool;

     procedure calculateaxis;
     procedure createstockhastic(candleSeries :TCandleSeries );

     procedure SetAnnotationPosition(Annotation: TAnnotationTool);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form6: TForm6;



implementation

{$R *.dfm}

procedure TForm6.Button1Click(Sender: TObject);
begin
   createstockhastic(tmpMyCandle);
   Chart1.Draw();
end;



procedure TForm6.Chart1DblClick(Sender: TObject);
begin
   ChartEditor1.Execute;
end;



procedure TForm6.Button2Click(Sender: TObject);
begin
   createstockhastic(tmpMyCandle);
   Chart1.Draw();
end;

procedure TForm6.calculateaxis;
var i: Integer;
begin

   for i:=Chart1.CustomAxes.count -1 downto 0 do
   begin
      ListBox1.Items.Add(IntToStr(i));
      Chart1.CustomAxes[i].StartPosition := i*120/Chart1.CustomAxes.Count;
      Chart1.CustomAxes[i].EndPosition   := (i+1)*100/Chart1.CustomAxes.Count;
   end;
end;


procedure TForm6.FormCreate(Sender: TObject);
var i: Integer;
    Years   : TChartAxis;
begin
   for i:= Chart1.SeriesList.Count-1 downto 0 do
   begin
     Chart1.RemoveSeries(Chart1[I]);
   end;

   if Chart1.Axes.Bottom.SubAxes.Count > 0 then
   begin
     for i:=  Chart1.Axes.Bottom.SubAxes.Count-1 downto 0 do
     begin
        Chart1.Axes.Bottom.SubAxes.Delete(i);
     end;
   end;


   Chart1.View3D:=false;
   Chart1.MarginLeft:=7;
   Chart1.Legend.HorizMargin:=40;

   for i:=0 to 1-1 do
   begin
     with Chart1 do
     begin
        tmpMyCandle := TCandleSeries.Create(self);

        tmpMyCandle.CandleStyle := csOpenClose;
        tmpMyCandle.Title := 'Candle' ;
        tmpMyCandle.Draw3D := False;
        tmpMyCandle.Dark3D := False;
        tmpMyCandle.DownCloseColor := clGreen;
        tmpMyCandle.DownCloseGradient.StartColor := clGreen;
        tmpMyCandle.HighLowPen.Color := clDefault;

        tmpMyCandle.UpCloseColor := clRed;
        tmpMyCandle.UpCloseGradient.StartColor := clRed ;

        tmpMyCandle.FillSampleValues(250);


        tmpAxis:=Chart1.CustomAxes.Add as TChartAxis;

        //tmpAxis.StartPosition:=i*120/StrToInt(edtSeries.text);
       // tmpAxis.EndPosition:=(i+1)*100/StrToInt(edtSeries.text);


        tmpAxis.Axis.Color:=Color;
        tmpAxis.Maximum := tmpMyCandle.CloseValues.MaxValue;
        tmpAxis.Minimum := tmpMyCandle.CloseValues.MinValue;
        tmpAxis.Automatic := false;
        tmpAxis.Increment := 50;
        tmpAxis.DisplayName := 'Henry';
        tmpMyCandle.CustomVertAxis:=tmpAxis;

        AddSeries(tmpMyCandle);
     end;
   end;

   Years:=Chart1.Axes.Bottom.SubAxes.Add;
   Years.Increment:= 365;
   Years.DateTimeFormat:='MM-YY';
   Years.LabelsFont.Color := clWhite;
   Years.Visible:=True;

   calculateaxis;

   Chart1.Draw;



end;


procedure TForm6.createstockhastic(candleSeries: TCandleSeries);
var
  I:Integer;
  tmpStockhastic:TLineSeries;
begin
   stockHastic := TStochasticFunction.Create(nil);

   with chart1 do
   begin
      tmpStockhastic := TLineSeries.Create(self);
      addSeries(tmpStockhastic);
      tmpStockhastic.SetFunction(stockHastic);
      tmpStockhastic.DataSources.Clear;
      tmpStockhastic.DataSources.Add( candleSeries );
      tmpStockhastic.FunctionType.Period := StrToInt(edtSeries.Text);
      tmpAxis:=Chart1.CustomAxes.Add as TChartAxis;
      tmpStockhastic.CustomVertAxis:=tmpAxis;
      tmpAxis.Axis.Color:=Color;


      ChartTool1 := TAnnotationTool.Create(nil);

      ChartTool1.Text:=FormatFloat('#0.00',(tmpStockhastic.YValue[tmpStockhastic.YValues.Count-1]));
      ChartTool1.Shape.Transparent:=True;
      ChartTool1.Shape.Font.Color:=clRed;
      Chart1.Tools.Add(ChartTool1);

      ListBox1.Items.Add('stockhastic '+FormatFloat('#0.00',(tmpStockhastic.YValue[tmpStockhastic.YValues.Count-1]))) ;

      SetAnnotationPosition(ChartTool1);

   end;

   calculateaxis;
   Chart1.Draw;
end;

procedure TForm6.SetAnnotationPosition(Annotation: TAnnotationTool);
var Value : Double;
    XPos  : Integer;
    YPos  : Integer;
    I    : Integer;
begin

  Value:=StrToFloat(Annotation.Text);

//  for i:= Chart1.SeriesList.Count-1 downto 0 do
//  begin
//    ListBox1.Items.Add('Series  '+Chart1.Tools.Items[i].LongDescription)  ;
//  end;

  // XPos:=Chart1.Axes.Bottom.IStartPos - Annotation.Width -
  //      Chart1.Axes.Left.TickLength ;


  with Chart1[0] do
  begin
    XPos:=Chart1.CustomAxes.Items[0].CalcPosValue(Value) - (Annotation.Height div 2);
    YPos:=50;
  end;

  { with Chart1.Tools[0] as TAnnotationTool do
   begin
    Chart1.Canvas.AssignFont(Shape.Font);
    Text:='Label in the Middle';
    XPos:=XPos-(Shape.Width div 2);
    YPos:=YPos-(Shape.Height div 2);
    if (Left<>XPos) or (Top<>YPos) then
    begin
      Left:=XPos;
      Top:=YPos;
      Chart1.Draw;
    end;
  end;
  }
  if Chart1.Animations.Count > 0 then
  begin
     for i:=   Chart1.Animations.Count-1 downto 0 do
     begin
        //Chart1.Tools.Delete(i);
        ListBox1.Items.Add('CHRT TOOLS  '+Chart1.Tools.Items[i].Description)  ;
        YPos:=Chart1.CustomAxes.Items[i].CalcPosValue(Value) - (Annotation.Height div 2);
     end;
  end;







  Annotation.Shape.CustomPosition:=True;
  Annotation.Shape.Left:=XPos+5;
  Annotation.Shape.Top:=YPos;

end;

end.
